<?php

/**
 * @file
 * Functions for theming fields.
 */

/**
 * Debugging.
 */
//  Print an array of all enabled fields.
// dpm(field_info_fields());

/**
 * Preprocess all fields.
 */
function grumpymonkey_preprocess_field(&$variables, $hook) {
  // dpm($variables, 'Preprocess field variables');
  // dpm($hook, 'Preprocess field hook');
  foreach ($variables['items'] as $key => $item) {
    $variables['items'][$key]['#item']['attributes']['class'][] = 'testing';
  // dpm($variables, 'Preprocess field variables CHANGED');
  }
}

/**
 * Process all fields.
 */
function grumpymonkey_process_field(&$variables, $hook) {
  // dpm($variables, 'Process field variables');
  // dpm($hook, 'Process field hook');
}

/**
 * Override of theme_field.
 *
 * - THEMENAME_field__body__article()
 * - THEMENAME_field__article()
 * - THEMENAME_field__body()
 * - THEMENAME_field()
 */
function grumpymonkey_field($variables) {
  $output = '';

  // Render the label, if it's not hidden.
  if (!$variables['label_hidden']) {
    $output .= '<div class="field-label"' . $variables['title_attributes'] . '>' . $variables['label'] . ':&nbsp;</div>';
  }

  // Render the items.
  $output .= '<div class="field-items"' . $variables['content_attributes'] . '>';
  foreach ($variables['items'] as $delta => $item) {
    $classes = 'field-item ' . ($delta % 2 ? 'odd' : 'even');
    $output .= '<div class="' . $classes . '"' . $variables['item_attributes'][$delta] . '>' . drupal_render($item) . '</div>';
  }
  $output .= '</div>';

  // Render the top-level DIV.
  $output = '<div class="' . $variables['classes'] . '"' . $variables['attributes'] . '>' . $output . '</div>';

  return $output;
}

/**
 * Theme theme_field for field_image
 */
function grumpymonkey_field__field_image($variables) {
  // dpm($variables, 'Theme function variables');
  $output = '';

  // Render the label, if it's not hidden.
  if (!$variables['label_hidden']) {
    $output .= '<p ' . $variables['title_attributes'] . '>' . $variables['label']. '</p>';
  }

  // Render the items.
  // dpm($variables['content_attributes']);
  foreach ($variables['items'] as $delta => $item) {
    // $classes = ($delta % 2 ? 'odd' : 'even');
    // $output .= '<div class="' . $classes . '"' . $variables['item_attributes'][$delta] . '>' . drupal_render($item) . '</div>';
    // dpm($variables['item_attributes'][$delta]);
    // dpm($item);
    $output .= drupal_render($item);
  }

  // Render the top-level DIV.
  // $output = '<div class="' . $variables['classes'] . '"' . $variables['attributes'] . '>' . $output . '</div>';
  // dpm($variables['attributes']);
  
  //echo('<code><p>Updated output for field_image</p>'. htmlentities($output) .'</code>');
  //echo('<code><p>Original output for field_image</p>'. htmlentities(theme_field($variables)) .'</code>');
  return $output;
}

/**
 * Theme theme_field for field_image
 */
function grumpymonkey_field__body($variables) {
  // dpm($variables, 'Theme function variables');
  $output = '';

  // Render the label, if it's not hidden.
  if (!$variables['label_hidden']) {
    $output .= '<p ' . $variables['title_attributes'] . '>' . $variables['label']. '</p>';
  }

  // Render the items.
  // dpm($variables['content_attributes']);
  foreach ($variables['items'] as $delta => $item) {
    // $classes = ($delta % 2 ? 'odd' : 'even');
    // $output .= '<div class="' . $classes . '"' . $variables['item_attributes'][$delta] . '>' . drupal_render($item) . '</div>';
    // dpm($variables['item_attributes'][$delta]);
    $output .= drupal_render($item);
  }

  // Render the top-level DIV.
  // $output = '<div class="' . $variables['classes'] . '"' . $variables['attributes'] . '>' . $output . '</div>';
  // dpm($variables['attributes']);
  
  //echo('<code><p>Updated output for body</p>'. htmlentities($output) .'</code>');
  //echo('<code><p>Original output for body</p>'. htmlentities(theme_field($variables)) .'</code>');
  return $output;
}

/**
 * Returns HTML for an image field formatter.
 *
 * @param $variables
 *   An associative array containing:
 *   - item: An array of image data.
 *   - image_style: An optional image style.
 *   - path: An array containing the link 'path' and link 'options'.
 *
 * @ingroup themeable
 */
function grumpymonkey_image_formatter($variables) {
  $item = $variables['item'];
  $image = array(
    'path' => $item['uri'],
    'alt' => $item['alt'],
  );

  // See http://drupal.org/files/drupal-1329586-10.patch
  // and http://drupal.org/node/1329586
  if (isset($item['attributes'])) {
    $image['attributes'] = $item['attributes'];
  }

  if (isset($item['width']) && isset($item['height'])) {
    $image['width'] = $item['width'];
    $image['height'] = $item['height'];
  }

  // Do not output an empty 'title' attribute.
  if (drupal_strlen($item['title']) > 0) {
    $image['title'] = $item['title'];
  }

  if ($variables['image_style']) {
    $image['style_name'] = $variables['image_style'];
    $output = theme('image_style', $image);
  }
  else {
    $output = theme('image', $image);
  }

  if (!empty($variables['path']['path'])) {
    $path = $variables['path']['path'];
    $options = $variables['path']['options'];
    // When displaying an image inside a link, the html option must be TRUE.
    $options['html'] = TRUE;
    $output = l($output, $path, $options);
  }

  return $output;
}